#!/usr/bin/perl -w

# Cancel invoices
use DBI;

do "common.cfg";

$db = DBI->connect("dbi:Pg:dbname=$dbname") or die("Unable to connect to $dbname");

# Global vars
my ($debtac_id, $salesac_id, $vatac_id, $all_template, $invh, $glbatchnr);
my $batchname = 'Annulerede fakturaer';

  ($debtac_id, $salesac_id, $vatac_id) = init();
  ($invh, $glbatchnr) = beginBatch();
  processBatch($debtac_id, $salesac_id, $vatac_id,
               $invh, $glbatchnr);

# ------ Init ------
sub init {
 $q = "SELECT coa_id FROM gl_chartofaccount WHERE number = $debacctnr";
 $sth = $db->prepare($q);
 $sth->execute or die("Can't execute $q\n");
 my ($debtac_id) = $sth->fetchrow();
 $q = "SELECT coa_id FROM gl_chartofaccount WHERE number = $salesacctnr";
 $sth = $db->prepare($q);
 $sth->execute or die("Can't execute $q\n");
 my ($salesac_id) = $sth->fetchrow();
 $q = "SELECT coa_id FROM gl_chartofaccount WHERE number = $vatacctnr";
 $sth = $db->prepare($q);
 $sth->execute or die("Can't execute $q\n");
 my ($vatac_id) = $sth->fetchrow();
 $sth->finish;
 return ($debtac_id, $salesac_id, $vatac_id);
};

sub beginBatch {
 my $q = "SELECT i.*, o.contact_id, o.paycode, o.yourref, c.name, c.custgrp_id, custtype, c.address1 as address, c.postalcode,
  c.city, date_trunc('month',invoicedate) AS periodnr
  FROM so_invoice i, so_orderhead o, co_custaddr_v c
  WHERE i.status = 9100 AND i.ordernr = o.ordernr
  AND o.contact_id = c.contact_id
  ORDER BY invoicenr";
 my $invh = $db->prepare($q);
 $invh->execute;
 exit 2 if !$invh->rows;

# DB start
 $db->{AutoCommit} = 0;
# GL start
 $q = "INSERT INTO gl_batch (system_id, type, batchnr, name, status, createddate, posteddate)
  VALUES (10001, 120001, 0, '$batchname', 200, 'now', 'now') ";
# print "$q\n";
 my $sth = $db->do($q);
 $q = "SELECT currval('gl_batchsequence')";
 $sth = $db->prepare($q);
 $sth->execute;
 die("Can't execute $q\n") if !$sth->rows;
 my ($glbatchnr) = $sth->fetchrow();

 return ($invh, $glbatchnr);
};

sub processBatch {
 ($debtac_id, $salesac_id, $vatac_id, $invh, $glbatchnr) = @_;
 my ($batchdr, $batchcr, $journalnr);
# ----- Invoice loop -----
 while (my $invoice = $invh->fetchrow_hashref) {
  my $periodnr = $invoice->{periodnr};
# SO update
  my $q = "UPDATE so_invoice SET status = 9200, updated='now' WHERE invoicenr = $invoice->{invoicenr}";
# print "$q\n";
  my $sth = $db->do($q);
  my ($custac_id) = $invoice->{custgrp_id} || 0;
  $q = "SELECT * FROM so_orderline WHERE ordernr = $invoice->{ordernr}";
  my $ordl = $db->prepare($q);
  $ordl->execute;
  next if !$ordl->rows;

# Totals
  my ($vat_pct, $prodac_id) = 0;

# ----- Invoice line loop -----
  while ($orderline = $ordl->fetchrow_hashref) {
# Amounts
   my $linevat_id = $vat_id;
   my $linetotal = $orderline->{linetotal};
   my $linevat = $orderline->{linevat};
   my $lineamt = $linetotal - $linevat;

# GL update / lines
   if ($orderline->{art_id}) {
    $q = "SELECT v.percent, p.pgrp_id
     FROM pd_vat v, pd_productgroup p, pd_article a
     WHERE a.art_id = $orderline->{art_id}
     AND a.pgrp_id = p.pgrp_id AND v.vat_id = p.vat_id";
    $sth = $db->prepare($q);
    $sth->execute;
    ($vat_pct, $prodac_id) = $sth->fetchrow();
   };
   $vat_pct = 0 if !$vat_pct;
   $prodac_id = 0 if !$prodac_id;
   ($batchdr, $batchcr, $journalnr) = updGLbalance($debtac_id, $prodac_id, $custac_id, $periodnr, 0, $linetotal, $batchname, $glbatchnr, $batchdr, $batchcr, $journalnr);
   ($batchdr, $batchcr, $journalnr) = updGLbalance($salesac_id, $prodac_id, $custac_id, $periodnr, $lineamt, 0, $batchname, $glbatchnr, $batchdr, $batchcr, $journalnr);
   ($batchdr, $batchcr, $journalnr) = updGLbalance($vatac_id, $prodac_id, $custac_id, $periodnr, $linevat, 0, $batchname, $glbatchnr, $batchdr, $batchcr, $journalnr);
  }	# ----- Finished lines -----
# Finish db
  my $rc = $db->commit;
 }
# End
 $q = "UPDATE gl_batch SET totaldr = $batchdr, totalcr = $batchcr WHERE batch_id = $glbatchnr";
# print "->$q\n";
 $sth = $db->do($q);
 my $rc = $db->commit;

 $invh->finish();

 $db->disconnect;
};

sub updGLbalance {
 my $ag_id;
 my ($coacct_id, $prodacct_id, $custacct_id, $periodnr, $debit, $credit, $text, $glbatchnr, $batchdr, $batchcr, $journalnr) = @_;
 $q = "SELECT gl_posting($coacct_id, $prodacct_id, $custacct_id, '$periodnr',
  $debit, $credit, '$text', $amounttype, $currency_id, $glbatchnr, ".++$journalnr.")";
# print "$q\n";
 $sth = $db->prepare($q);
 $sth->execute or return $sth->errstr;                                          
 $batchdr += $debit;
 $batchcr += $credit;
 return ($batchdr, $batchcr, $journalnr);
}

sub help {
 print "Syntax: co.pl\n";
 exit 1;
}
