# [gl_reportwriter report_id year]
#
# This tag returns a table constructed from gl_report
#
UserTag  gl_reportwriter  Order report_id year
UserTag  gl_reportwriter  PosNumber 2
UserTag  gl_reportwriter  Routine <<EOF

sub {
  my ($report,$yr) = @_;
  
  my $db = $Db{gl_report} or return "Can't open gl_report";
  
  sub makeSql {
   my ($yr, $rowref, $col_ref) = @_;
   my @row = @$rowref;
   if ($row[2] == 1) {		# ----- Account row
     my ($acct1,$acct2,$rowtext,$rr_agg) = ($row[5],$row[6],$row[4],$row[11]);
     my ($fromacct,$frompgrp,$fromcgrp) = split(/\//,$acct1);
     $acct2 ||= $acct1;
     my ($toacct,$topgrp,$tocgrp) = split(/\//,$acct2);
     $topgrp ||= $frompgrp;
     $tocgrp ||= $tocgrp;
     my $q = "SELECT SUM(gb.perioddr) AS debit, SUM(gb.periodcr) AS credit";
     my ($grp, $ord);
     my $where = "AND gc.number BETWEEN '$fromacct' AND '$toacct'";;
     if (!$rr_agg) {
      $q .= ",gc.number, gn.name";
      $grp .= ", gc.number, gn.name";
      $ord .= ", gc.number";
     } else { $q .= ",'','$rowtext'"};
     $where .= "\nAND (";		# We trust that there's at least one col
     my ($colq, $colgrp, $colord);
     foreach my $colref (@$col_ref) {
       my @col = @$colref;
       next if $col[4] != 1;		# Only account columns!
       my ($fromper,$toper,$rc_agg) = ($col[6],$col[8],$col[10]);
       $toper ||= $fromper;
       my $fromper = $yr . '-' . $fromper . '-01';
       my $toper = $yr . '-' . $toper . '-01';
       $where .= "gb.periodnr BETWEEN '$fromper' AND '$toper' OR ";
  # rc_agg always set to false for now
       $rc_agg=0;
       if (!$rc_agg) {
        $colq = ",gb.periodnr";
        $colgrp = ", gb.periodnr";
        $colord = ", gb.periodnr";
       };
     };
     $q .= $colq;
     $grp .= $colgrp;
     $ord .= $colord;
     $where = substr($where,0,-4) . ")\n";	# Finish period choice
     if ($frompgrp) {
      $q .= ", ga.dim2";
      if ($frompgrp ne '-') {
        $where .= " AND ga.dim2 BETWEEN $frompgrp AND $topgrp";
      } else {
        $where .= " AND ga.dim2 IS NULL";
      };
      $grp .= ", ga.dim2";
      $ord .= ", ga.dim2";
     };
     if ($fromcgrp) {
      $q .= ", ga.dim3";
      if ($fromcgrp ne '-') {
        $where .= " AND ga.dim3 BETWEEN $fromcgrp AND $tocgrp";
      } else {
        $where .= " AND ga.dim3 IS NULL";
      };
      $grp .= ", ga.dim3";
      $ord .= ", ga.dim3";
     };
     $grp =~ s/,//;				# Remove first comma
     $ord =~ s/,//;				# Remove first comma

     $q .= " 
       FROM gl_chartofaccount gc, gl_acctname gn, gl_balance gb, gl_acctgrid ga
       WHERE gc.ac_id = gn.ac_id AND gb.ag_id = ga.ag_id
       AND gc.coa_id = ga.dim1
       $where
       GROUP BY $grp
       ORDER BY $ord
     ";
# my $qq = $db->quote($q) or return "Quote failed: $q";
# $db->query("INSERT INTO queries VALUES ($qq)");
     return $q;
   };
  };
  
  sub calcRow {
   my @dt;
   my ($yr, $rowref, $col_ref, $q) = @_;
   my @row = @$rowref;
   my $label;
   if ($row[2] == 1) {		# ----- Account row
     ($dt[0]{name},$label) = @row[4,3];
     my $ary = $db->query($q) or return "Query failed: $q";
     for (@$ary) {
       my ($dbt,$crt,$acctnr,$rowname,$date,$pgrp,$cgrp) = (@$_);
       $dt[0]{name} ||= $rowname;
       my ($r,$dm,$r) = split(/-/,$date);
       foreach my $colref (@$col_ref) {	# Account columns
         my @col = @$colref;
         next if $col[4] != 1;
         my ($line, $cfm, $ctm) = @col[1,6,8];
         $ctm ||= $cfm;
         if ($cfm<=$dm and $dm<=$ctm) {
           $dt[$line]{debit} += $dbt;
           $dt[$line]{credit} += $crt;
         }
       }
     }
     foreach my $colref (@$col_ref) {	# Formula columns
       my @col = @$colref;
       next if $col[4] != 2;
       my ($line,$fsign1,$from,$fsign2,$to) = @col[1,11,12,13,14];
       if ($fsign1 == 1) {
         $dt[$line]{debit} = $dt[$from]{debit};
         $dt[$line]{credit} = $dt[$from]{credit};
       }
       if ($fsign1 == 2) {
         $dt[$line]{debit} = -$dt[$from]{debit};
         $dt[$line]{credit} = -$dt[$from]{credit};
       }
       if ($fsign1 == 3) {
         $dt[$line]{debit} = 0;
         $dt[$line]{credit} = 0;
         for (my $i=$from;$i<=$to;$i++) {
           $dt[$line]{debit} += $dt[$i]{debit};
           $dt[$line]{credit} += $dt[$i]{credit};
         }
       }
       if ($fsign2 == 1) {
         $dt[$line]{debit} += $dt[$to]{debit};
         $dt[$line]{credit} += $dt[$to]{credit};
       }
       if ($fsign2 == 2) {
         $dt[$line]{debit} -= $dt[$to]{debit};
         $dt[$line]{credit} -= $dt[$to]{credit};
       }
     }
   }
   if ($row[2] == 2) {		# ----- Formula row
     my @col = @$col_ref;
     $dt[0]{cols} = $#col + 1;
     ($dt[0]{name},$dt[0]{sign1},$dt[0]{from},$dt[0]{sign2},$dt[0]{to},$label) = @row[4,7,8,9,10,3];
   }
   return $label, @dt;
  }

  sub calcData {
   my ($yr, $lbl, $d) = @_;
   my %label = %$lbl;
   my @data = @$d;
   my $line = 0;
   for my $dv (@data) {
     my @dt = @$dv;
     if ($dt[0]{sign1}) {
       my ($cols,$sign1,$from,$sign2,$to) = ($dt[0]{cols},$dt[0]{sign1},$dt[0]{from},$dt[0]{sign2},$dt[0]{to});
       $from = $label{$from};
       $to = $label{$to};
       for (my $i=1;$i<=$cols;$i++) {
         if ($sign1 == 1) {
           $dt[$line][$i]{debit} = $dt[$from][$i]{debit};
           $dt[$line][$i]{credit} = $dt[$from][$i]{credit};
         }
         if ($sign1 == 2) {
           $dt[$line][$i]{debit} = -$dt[$from][$i]{debit};
           $dt[$line][$i]{credit} = -$dt[$from][$i]{credit};
         }
         if ($sign1 == 3) {
           for (my $j=$from;$j<=$to;$j++) {
             $data[$line][$i]{debit} += $data[$j][$i]{debit};
             $data[$line][$i]{credit} += $data[$j][$i]{credit};
           }
         }
         if ($sign2 == 1) {
           $dt[$line][$i]{debit} += $dt[$to][$i]{debit};
           $dt[$line][$i]{credit} += $dt[$to][$i]{credit};
         }
         if ($sign2 == 2) {
           $dt[$line][$i]{debit} -= $dt[$to][$i]{debit};
           $dt[$line][$i]{credit} -= $dt[$to][$i]{credit};
         }
       }
     }
     $line++;
   }
  @data;
  }

  sub formatRow {
   my ($yr, @dt) = @_;
   my $ret = "<TR><TD align=\"left\">$dt[0]{name}:</TD>";
   for (my $i=1;$i<=$#dt;$i++) {
     $ret .= "<TD align=\"right\">$dt[$i]{debit}</TD><TD align=\"right\">$dt[$i]{credit}</TD>"
   };
   $ret .= "</TR>\n";
  }

  sub makeHeader {
   my ($col_ref) = @_;
   my $ret = "<TR><TH></TH>";
   foreach my $colref (@$col_ref) {	# Account columns
     my @col = @$colref;
     my $header = $col[2];
     $ret .= "<TH align=\"center\" colspan=\"2\"><B>$header</B></TH>";
   };
   $ret .= "</TR>\n<TR><TH align=\"left\"><B>Description</B></TH>";
   my @col = @$col_ref;
   for (my $i = 0; $i<=$#col; $i++) {
     $ret .= "<TH align=\"right\"><B>Debit</B></TH><TH align=\"right\"><B>Credit</B></TH>";
   }
   $ret .= "</TR>\n";
  }
  
   my $q = "SELECT row_id, col_id FROM gl_report WHERE glreport_id = $report";
   my $report_ary = $db->query($q) or return "Query failed: $q";
   my @report = @$report_ary;
   my @r1 = @{$report[0]};
   my $row_id = $r1[0];
   my $col_id = $r1[1];
   my $q = "SELECT * FROM gl_reportrow WHERE row_id = $row_id ORDER BY linenr";
   my $row_ary = $db->query($q) or return "Query failed: $q";
   $q = "SELECT * FROM gl_reportcol WHERE col_id = $col_id ORDER BY linenr";
   my $col_ary = $db->query($q) or return "Query failed: $q";
   my $txt = "<table>" . makeHeader($col_ary);
   my (@data, %label);
   for (@$row_ary) {
     my $rowref = $_;
     $q = makeSql($yr, $rowref, $col_ary);
     my ($lbl, @d) = calcRow($yr, $rowref, $col_ary, $q);
     push @data, [ @d ];
     $label{$lbl} = $#data if $lbl;
   }
   @data = calcData($yr, \%label, \@data);
   for my $d (@data) {
     $txt .= formatRow($yr, @$d);
   }
   $txt .= "</table>";
   return $txt;
  }
EOF

